<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_admin
{

    public function sd_add_menu_pages()
    {
        add_menu_page(
            __('Delivery', 'saintpackages'), //page title
            __('Delivery', 'saintpackages'), //menu item title
            'manage_options', //access level
            'saint-delivey-admin',    //page id
            [$this, 'sd_create_admin_page'], //item render function
            '',
            51 // menu item order
        );

       add_submenu_page('saint-delivey-admin',
            'Usuarios',
            'Usuarios',
            'manage_options',
            'saint-delivey-user-wp',
            __CLASS__ . '::sp_render_detail'
        );
        add_action('admin_init', [$this, 'page_init']);
    }

    public function page_init()
    {
        register_setting(
            'sd_settings', // Option group
            'sd_settings', // Option name
            array($this, 'sanitize') // Sanitize
        );

       register_setting(
            'sd_users', // Option group
            'sd_users', // Option name
           array($this, '') // Sanitize
        );

        add_settings_section(
            'sd_settings', // ID
            __(''), // Title
            false, // Callback
            'saint-delivey-admin&tab=display_sd_settings' // Page
        );

        add_settings_section(
            'sd_users', // ID
            __(''), // Title
            [$this, 'user_wp_service'], // Callback
            'saint-delivey-admin&tab=display_sd_users' // Page
        );

      add_settings_field(
            'sd_user_wp', // ID
            __(''), // Title
            [$this, 'sd_server_input_user_callback'], // Callback
            'saint-delivey-admin&tab=display_sd_user', // Page
            'sd_users' // Section
        );

        add_settings_field(
            'sd_server', // ID
            __('SDK URL:', 'saintpackages'), // Title
            [$this, 'sd_server_input_callback'], // Callback
            'saint-delivey-admin&tab=display_sd_settings', // Page
            'sd_settings' // Section
        );

        add_settings_field(
            'sd_user', // ID
            __('Usuario del SDK:', 'saintpackages'), // Title
            [$this, 'sd_sdk_user_input_callback'], // Callback
            'saint-delivey-admin&tab=display_sd_settings', // Page
            'sd_settings' // Section
        );

        add_settings_field(
            'sd_user_password', // ID
            __('Contraseña para el Usuario del SDK', 'saintpackages'), // Title
            [$this, 'sd_user_password_input_callback'], // Callback
            'saint-delivey-admin&tab=display_sd_settings', // Page
            'sd_settings' // Section
        );

    }

    public function sanitize($input)
    {
        $new_input = [];
        if (isset($input['sd_server']))
            $new_input['sd_server'] = sanitize_text_field($input['sd_server']);

        if (isset($input['sd_user']))
            $new_input['sd_user'] = sanitize_text_field($input['sd_user']);

        if (isset($input['sd_user_password']))
            $new_input['sd_user_password'] = sanitize_text_field($input['sd_user_password']);

        return $new_input;
    }



    public function sd_server_input_callback()
    {
        printf(
            '<input type="text" id="sd_server" name="sd_settings[sd_server]" value="%s" />',
            isset($this->options['sd_settings']['sd_server']) ? esc_attr($this->options['sd_settings']['sd_server']) : ''
        );
    }

    public function sd_sdk_user_input_callback()
    {
        printf(
            '<input type="text" id="sd_user" name="sd_settings[sd_user]" value="%s" />',
            isset($this->options['sd_settings']['sd_user']) ? esc_attr($this->options['sd_settings']['sd_user']) : ''
        );
    }

    public function sd_user_password_input_callback()
    {
       printf(
            '<input type="password" id="sd_user_password" name="sd_settings[sd_user_password]" value="%s" />',
            isset($this->options['sd_settings']['sd_user_password']) ? esc_attr($this->options['sd_settings']['sd_user_password']) : ''
        );
    }

    public function sd_server_input_user_callback()
    {
        $sd_utilities = new sd_utilities();
        $sd_utilities->get_view('sd_user_wp', ['templates']);
    }

    public function sd_create_admin_page()
    {
        //set view params
        $this->options = [
            'sd_settings' => get_option('sd_settings')
        ];
        $sd_utilities = new sd_utilities();
        $sd_utilities->get_view('sd_admin');
    }

    public function sp_render_detail()
    {
        $options_detail = [
            'sd_user' => get_option('sd_user')
        ];
        $sd_utilities = new sd_utilities();
        $sd_utilities->get_view('sd_user_wp');
    }

    public function sd_imput_user_wp()
    {
       // if (isset($_SESSION[ 'sp_user_token' ]) or is_null($_SESSION[ 'sp_user_token' ] == false) )

        $sd_utilities = new sd_utilities();
        $sd_utilities->get_view('sd_user');

    }
    public function sd_imput_service()
{

    //if (isset($_SESSION[ 'sp_user_token' ]) or is_null($_SESSION[ 'sp_user_token' ] == false))

    $sd_utilities = new sd_utilities();
    $sd_utilities->get_view('sd_service');

}
    public function user_wp_service()
    {
        $options_detail = [
            'sd_users' => get_option('sd_users')
        ];
        $sd_utilities = new sd_utilities();
        $sd_utilities->get_view('sd_user_wp');
    }




}