<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_utilities {


    /**
     * devuelve una vista del plugin
     * @param $view string nombre de la vista
     * @param $tmpl string nombre del templates a mostrar
     * @param $tmpl_pdf string nombre del templates en formato pdf a mostrar
     * @return mixed
     */
    public function get_view( $view = null, $tmpl = null, $tmpl_pdf = null ) {
        if ( isset( $view ) ) {

            $format = sd_utilities::sd_get_var( 'sd_format', 'get' );

            $template = '';

            switch ( $format ) {
                case 'pdf' :
                    if ( isset( $tmpl_pdf ) && $tmpl_pdf != '' ) {
                        $template = $tmpl_pdf . '_pdf';
                    }
                    else {
                        $template = 'default_pdf';
                    }
                    break;
                default :
                    if ( isset( $tmpl ) && $tmpl != '' ) {
                        $template = $tmpl;
                    }
                    else {
                        $template = 'default';
                    }
                    break;
            }


            $path = SAINT_DELIVERY_PATH . 'views/' . $view . '/view.php';
            include_once $path;
        }
        else {
            return __( 'Error, vista no especificada', 'saintpackages' );
        }
    }

   public function get_template( $view = null, $template = null, $data = null ) {
        if ( isset( $view ) && isset( $template ) ) {

            $override_path = get_template_directory() . '/saintpackingdelivery/views/' . $view . '/' . $template . '.php';
            $path = SAINT_DELIVERY_PATH . 'views/' . $view . '/templates/' . $template . '.php';
            $items = $data;

            if ( !isset( $items ) || $items->Status != 0 ) {
                $items = [];
            }
            else {
                $items = $data->Data;
            }

            if ( $template == 'default' && file_exists( $override_path ) ) {
                include_once $override_path;
            }
            elseif ( $template != 'default' && file_exists( $override_path ) ) {
                include_once $override_path;
            }
            else {
                include_once $path;
            }

        }
        else {
            return __( 'Error, vista o templates no especificado', 'saintpackages' );
        }
    }
    public static function get_config() {
        $config = [
            'server' => get_option( 'sd_settings' )[ 'sd_server' ],
            'user' => get_option( 'sd_settings' )[ 'sd_user' ],
            'user_password' => get_option( 'sd_settings' )[ 'sd_user_password' ],

        ];

        return $config;
    }

    public static function sd_get_var( $var, $method ) {

        switch ( $method ){
            case 'post' :
                $method = INPUT_POST;
                break;
            case 'get' :
                $method = INPUT_GET;
                break;
            default :
                $method = 0;
                break;
        }

        $clean = filter_input( $method, $var, FILTER_SANITIZE_STRING );
        return $clean;
    }

    }