<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_ListarServidores
{
    public function get_service()
    {
        try {
            $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CampoOrden = '';
            $params->ExpresionFiltro = '';
            $params->Orden = '';
            $params->RegistroInicial = 0;
            $params->RegistrosPorPagina = 10;


            $client = new SoapClient($config['server']);

            $data = $client->Adm_Mae_ListarServidores(
                ['parametro' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Adm_Mae_ListarServidoresResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Adm_Mae_ListarServidores(
                    ['parametro' => $params, "_token" => $token]
                );
                $item = json_decode($data->Adm_Mae_ListarServidoresResult)->Data;

            }
            else if ($status == 0){
                $item = json_decode($data->Adm_Mae_ListarServidoresResult)->Data;
            }
        } catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler( 'sdk', $e );
        }
        return $item;

    }
}
