<?php
/**
 * Plugin Name: Saint Packing Delivery
 * Plugin URI: https://saintnet.com/
 * Description: Plugin para la entrega de empaque de productos, Saint de Venezuela
 * Author: Saint de Venezuela
 * Author URI: https://saintnet.com/
 * Version: 1.0.0
 * Text Domain: saintpackingdelivery
 * Domain Path: /i18n/languages/
 */
if ( ! defined( 'ABSPATH' ) ) exit; //Exit if accessed directly.

if ( ! class_exists( 'saintpackingdelivery' ) ) {

    class saintpackingdelivery {


        public function init() {
            add_action( 'init' ,  __CLASS__ . '::constants' );
            add_action( 'init',  __CLASS__ . '::sd_includes', 1 );
            add_action( 'init', __CLASS__ . '::sd_session' , 2 );
            add_action('init', __CLASS__ . '::script');


            if( !is_admin() ) {

             add_action( 'init', __CLASS__ . '::add_site_styles' );
             add_action( 'init', __CLASS__ . '::add_site_scripts' );

           }
            if (is_admin() ) {
                add_action( 'init' , __CLASS__ . '::add_admin_styles' );
            add_action( 'admin_menu',  __CLASS__ . '::sd_admin' );


        }

        }
        public function sd_includes() {
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_errors.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_models.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/shortcodes/sd_shortcodes.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_templates.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_utilities.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_sessions.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_params.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/models/sd_ListarServidores.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_ajax.php';
            include_once ABSPATH . 'wp-content/plugins/saintpackingdelivery/includes/plg/sd_configuracion.php';
        }

        public function add_site_styles() {
            wp_enqueue_style( 'sp_bootstrap' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/libs/bootstrap-3.3.6/css/bootstrap.min.css' ) ) , false , '1.0.0' , 'all' );
            wp_enqueue_style( 'sp_jquery_ui_styles' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/css/jquery-ui.theme.min.css' ) ) , false , '1.0.0' , 'all' );
            wp_enqueue_style( 'sd_admin_styles' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/css/sd_admin_styles.css' ) ) , false , '1.0.0' , 'all' );
            wp_enqueue_style( 'sp_site_styles' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/css/sp_site_styles.css' ) ) , false , '1.0.0' , 'all' );
            wp_enqueue_style( 'dashicons' );

         }
         public function add_site_scripts() {
            wp_enqueue_script( 'sp_bootstrap' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/libs/bootstrap-3.3.6/js/bootstrap.min.js' ) ), [ 'jquery' ] );
            wp_enqueue_script( 'sp_scripts' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/js/scripts.js' ) ), [ 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker' ] );wp_enqueue_script( 'sp_qrcode' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/js/qrcode.min.js' ) ), [ 'jquery' ] );
         }

         public function add_admin_styles() {
             wp_enqueue_style( 'sd_admin_styles' , plugins_url( plugin_basename( dirname( __FILE__ ) . '/assets/css/sd_admin_styles.css' ) ) , false , '1.0.0' , 'all' );
         }


         public function constants() {
             define( 'SAINT_DELIVERY_PATH', plugin_dir_path( __FILE__ ) );
         }

        public function sd_admin() {
            include_once ABSPATH .  'wp-content/plugins/saintpackingdelivery/includes/admin/sd_admin.php';
            $sd_admin = new sd_admin();
            $sd_admin->sd_add_menu_pages();
        }

        public function sd_session() {
            session_start();
            if ( !isset(  $_SESSION[ 'sd_user_token' ] ) ||  $_SESSION[ 'sd_user_token' ] == '' ) {
                try {
                    $config = sd_utilities::get_config();

                   $client = new SoapClient( $config[ 'server' ] );
                    $login = $client->SEG_LoginSaint(
                        [ "idUser" => $config[ 'user' ], "password" => $config[ 'user_password' ] ]
                    );
                    $token = json_decode( $login->SEG_LoginSaintResult )->Message;
                    $_SESSION[ 'sd_user_token' ] = $token;
                }
                catch( Exception $e ) {
                    $error_handler = new sd_errors();
                    $error_handler->token_error_handler();
                }
            }
        }

        public  function script(){

            if( !is_admin() ) {
                wp_enqueue_script( 'sd_delivery', plugins_url( plugin_basename( dirname( __FILE__ ) .  '/assets/js/sd_delivery.js' ) ), [ 'jquery'] );
                wp_localize_script(
                    'sd_delivery', 'sd_ajax_object',
                    [
                        'ajax_url' => admin_url( 'admin-ajax.php' ),
                        'lang_detalle_entrega' => __( 'Detalle de Entrega', 'saintpackages' ),
                        'lang_codigo_entrega' => __( 'Codigo de Entrega', 'saintpackages' ),
                        'lang_aceptar' => __( 'Crear Entrega', 'saintpackages' ),
                        'lang_entrega' => __( 'Entrega Asignada', 'saintpackages' ),
                        'lang_existe' => __( 'No existe el documento', 'saintpackages' ),
                        'lang_error_crear_documento' => __( 'Error creando el documento', 'saintpackages' ),
                        'lang_exit' => ( 'Salir'),
                        'lang_entregado' => __( 'Paquete entregado', 'saintpackages' )
                    ]
                );
            }
            add_action( 'wp_ajax_sd_delivery', 'sd_ajax::ajax_delivery' );
            add_action( 'wp_ajax_nopriv_sd_delivery', 'sd_ajax::ajax_delivery' );
            add_action( 'wp_ajax_sd_create_delivery', 'sd_ajax::CrearEmtrega' );
            add_action( 'wp_ajax_nopriv_sd_create_delivery', 'sd_ajax::CrearEmtrega' );


           if( is_admin() ) {
               wp_enqueue_script( 'sd_script', plugins_url( plugin_basename( dirname( __FILE__ ) .  '/assets/js/sd_script.js' ) ), [ 'jquery'] );
                wp_localize_script(
                'sd_script', 'sd_ajax_object',
                [
                'ajax_url' => admin_url( 'admin-ajax.php' ),
                'lang_update_user_meta' => __( 'Usuario Actualizado', '' ),
                 ]
            );
           }
            add_action( 'wp_ajax_get_user_meta', 'sd_configuracion::get_user_meta' );
            add_action( 'wp_ajax_nopriv_get_user_meta', 'sd_configuracion::get_user_meta' );
            add_action( 'wp_ajax_add_user_meta', 'sd_configuracion::add_user_meta' );
            add_action( 'wp_ajax_nopriv_add_user_meta', 'sd_configuracion::add_user_meta' );
            add_action( 'wp_ajax_update_user_meta', 'sd_configuracion::update_user_meta' );
            add_action( 'wp_ajax_nopriv_update_user_meta', 'sd_configuracion::update_user_meta' );
        }
    }
    saintpackingdelivery::init();
}